{$I-,R-,S-}

library PDFThumbnailPlugin;

uses Windows, ComObj, Ole2;

{$R *.RES}

{$INCLUDE DescAPI.inc}

const VersionStr = '0.11';
      CopyrightStr = '(c) December 2004, Robert Galle';

function ImportPDFThumbnail(PDFFileName: string; lpImportThumbnailInfo: TThumbnailPtr): Integer;
var PDF_Doc, PDF_Rect, PDF_Page: Variant;
begin
  Result:=-1;
  CoInitialize(nil);
  try
     // init Adobe Acrobat COM interface
     // this will fail with exception if full Adobe Acrobat is not installed
     PDF_Doc:=CreateOleObject('AcroExch.PDDoc');
     PDF_Rect:=CreateOleObject('AcroExch.Rect');
     try
        try
           // open the PDF file and acquire first available page from Adobe Acrobat
           PDF_Doc.Open(PDFFileName);
           PDF_Page:=PDF_Doc.AcquirePage(0);
           // prepare rectangle and copy page to clipboard
           PDF_Rect.Top    := 0;
           PDF_Rect.Left   := 0;
           PDF_Rect.Right  := PDF_Page.GetSize.x;
           PDF_Rect.Bottom := PDF_Page.GetSize.y;
           PDF_Page.CopyToClipboard(PDF_Rect, 0, 0, 100);
           // now open clipboard and store a copy of bitmap available there
           OpenClipboard(0);
           lpImportThumbnailInfo.BitmapHandle:=CopyImage(GetClipboardData(CF_BITMAP), IMAGE_BITMAP, 0, 0, LR_COPYRETURNORG);
           // clean up clipboard after ourselves
           EmptyClipboard;
           CloseClipboard;
           PDF_Doc.Close;
           // if we have a valid bitmap handle, we were successful
           if lpImportThumbnailInfo.BitmapHandle<>0 then Result:=0;
        except
        end;
     finally
        VarClear(PDF_Rect);
        VarClear(PDF_Doc);
     end;
  finally
     CoUninitialize;
  end;
end;


//****************************************************************************
//                      Description API 2.0 interface
//****************************************************************************

procedure ModuleInfoEx(ModuleInfo: TModuleInfoPtr); stdcall;
begin
  with ModuleInfo^ do begin
     LStrCpy(lpszModuleName, 'WhereIsIt PDF Thumbnails Module');
     LStrCpy(lpszAuthor, 'Robert Galle');
     LStrCpy(lpszVersion, VersionStr);
   end;
end;

procedure ConfigureProc(HInstance: THandle; OwnerWnd: THandle; PluginID: Word); stdcall;
begin
  MessageBox(OwnerWnd,
    PChar('WhereIsIt PDF Thumbnails Module'#13'Version '+VersionStr+#13#13+
          '"Adobe Acrobat PDF Thumbnails" plugin'+#13#13+CopyrightStr),
    'About PDFThumbnailPlugin.DLL', MB_IconInformation+MB_OK);
end;

procedure RegisterDescPlugins(RegisterPlugin: TRegisterPlugin); stdcall;
begin
   RegisterPlugin(0, ptThumbnails, 'Adobe Acrobat PDF Thumbnails', '*.PDF', ConfigureProc);
end;

function ImportThumbnailProcEx(PluginID: Word; lpImportThumbnailInfo: TThumbnailPtr): Integer; stdcall;
begin
   IOResult;
   try
      with lpImportThumbnailInfo^ do
         case PluginID of
            0: Result:=ImportPDFThumbnail(RequireFileProc(FileName),lpImportThumbnailInfo);
            else Result:=-2;
         end;
      if lpImportThumbnailInfo.BitmapHandle>0 then Result:=0;
   except
      Result:=-1;
   end;
end;

exports
  ModuleInfoEx,
  RegisterDescPlugins,
  ImportThumbnailProcEx;

end.

